//package maestro.lib.graphics;
//PR.java

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;
//mport maestro.lib.graphics.*;
//import maestro.lib.math.*;

public class PR extends Panel implements ActionListener{
	//protected static final Color bgcolor = new Color(180,147,112);
	//protected static final Color bgcolor = new Color(200,200,200);
	private static final Color bgcolor = new Color(236,236,221);
	protected TextField text1[];
	protected Label lab1[], lab2[];
	public Label titlelabel;
	public Button b1;
	protected String titulo="Unknown Title";
	protected String[] nome;
	protected String[] unidade;
	protected static final Font labfont=new Font("SanSerif",Font.PLAIN,12);
	protected static final Font titlefont=new Font("SanSerif",Font.BOLD,14);
        protected double[] DValue;
	protected int indexsize;
	GridBagLayout gb = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	
	public PR(String titulo, String[] nome, String[] unidade){
	
		super();
		setLayout(gb);
		this.indexsize=nome.length;
		this.titulo=titulo;
		this.nome=new String[indexsize];
		this.unidade=new String[indexsize];
		this.DValue=new double[indexsize];
		this.text1=new TextField[indexsize];
		this.lab1=new Label[indexsize];
		this.lab2=new Label[indexsize];
		int i;
		titlelabel = new Label(titulo,Label.CENTER);
		//titlelabel.setBounds(5,5,300,40);   
		titlelabel.setFont(titlefont);
		try{
		MaestroG.addComponent(this,titlelabel,0,0,3,1,
			GridBagConstraints.BOTH,GridBagConstraints.CENTER);
		
		
		}  catch(Exception e){e.printStackTrace();}
		for(i=0;i<indexsize;i++){
			this.nome[i]=nome[i];
			this.unidade[i]=unidade[i];
			this.DValue[i]=0.0;

			this.text1[i]=new TextField("0.0",8);
			try{
			MaestroG.addComponent(this,text1[i],1,i+1,1,1,
			    GridBagConstraints.BOTH,GridBagConstraints.CENTER);
			}  catch(Exception e){e.printStackTrace();}
			this.lab1[i]=new Label(nome[i],Label.RIGHT);
			this.lab2[i]=new Label(unidade[i],Label.LEFT);
			this.lab1[i].setFont(labfont);
			this.lab2[i].setFont(labfont);
			
			try{
			MaestroG.addComponent(this,lab1[i],0,i+1,1,1,
			    GridBagConstraints.BOTH,GridBagConstraints.WEST);
			} catch(Exception e){e.printStackTrace();}
			try{
			MaestroG.addComponent(this,lab2[i],2,i+1,1,1,
			    GridBagConstraints.BOTH,GridBagConstraints.CENTER);
			}
			catch(Exception e){e.printStackTrace();}
		    
		}
		
		setBackground(bgcolor);
		
		b1 = new Button("Update");
		b1.setBackground(bgcolor);
		try{
		MaestroG.addComponent(this,b1,1,indexsize+1,1,1,
			    GridBagConstraints.BOTH,GridBagConstraints.CENTER);
		}
		catch(Exception e){e.printStackTrace();}
		//Listeners
		b1.addActionListener(this);
	}
	
	public void paint(Graphics g){
	    g.clearRect(0,0,getSize().width,getSize().height);
	    g.setColor(bgcolor.darker());
	    g.fillRect(0,getSize().height-2,getSize().width,2);
	    g.fillRect(getSize().width-2,0,2,getSize().height);
	    g.setColor(bgcolor.brighter());
	    g.fillRect(0,0,2,getSize().height-1);
	    g.fillRect(0,0,getSize().width-2,2);
	    
	    g.setColor(Color.black);
	    g.drawString("L",82,65);
	    g.drawString("=",95,55);
	    
	}
	
	public void actionPerformed(ActionEvent evt){
		if(evt.getSource() == b1){
		  for(int i=0;i<indexsize;i++){
		  	DValue[i]=Double.valueOf(text1[i].getText()).doubleValue();
                  }
		}
	}
	
        public double getValue(int i){
		return DValue[i];	
        }

        public synchronized void setValue(double D,int i){
		text1[i].setText(String.valueOf(D));
	}
}

